"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Browser_1 = require("../models/Browser");
var NightmarePage_1 = require("../pages/NightmarePage");
var NightmareBrowser = (function (_super) {
    __extends(NightmareBrowser, _super);
    function NightmareBrowser() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = 'nightmare';
        _this.pages = [];
        return _this;
    }
    NightmareBrowser.prototype.init = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.options = options || this.options;
                return [2 /*return*/, this];
            });
        });
    };
    NightmareBrowser.prototype.newPage = function () {
        return __awaiter(this, void 0, void 0, function () {
            var options, sessionId, initNMOptions, instance, page;
            return __generator(this, function (_a) {
                options = this.options;
                sessionId = options.sessionId ? 'persist: ' + options.sessionId : null;
                initNMOptions = {
                    switches: {
                        'ignore-certificate-errors': options.ignoreHTTPSErrors
                    },
                    webPreferences: {
                        showImages: options.showImages,
                        partition: sessionId
                    },
                    waitTimeout: options.waitTimeout,
                    show: options.show,
                };
                instance = this.model(initNMOptions);
                page = new NightmarePage_1.default(options, instance);
                this.pages.push(page);
                return [2 /*return*/, page];
            });
        });
    };
    NightmareBrowser.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var closePromises;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        closePromises = this.pages.map(function (page) {
                            if (!page.isClosed()) {
                                return page.close();
                            }
                            return Promise.resolve();
                        });
                        return [4 /*yield*/, Promise.all(closePromises)];
                    case 1:
                        _a.sent();
                        this.pages = [];
                        return [2 /*return*/];
                }
            });
        });
    };
    return NightmareBrowser;
}(Browser_1.default));
exports.default = NightmareBrowser;
//# sourceMappingURL=NightmareBrowser.js.map