"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Browser_1 = require("../models/Browser");
var PuppeteerPage_1 = require("../pages/PuppeteerPage");
var utils_1 = require("../utils");
var PuppeteerBrowser = (function (_super) {
    __extends(PuppeteerBrowser, _super);
    function PuppeteerBrowser() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = 'puppeteer';
        return _this;
    }
    PuppeteerBrowser.prototype.init = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var browser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = options || this.options;
                        this.options = options;
                        return [4 /*yield*/, this.model.launch({
                                headless: !options.show,
                                ignoreHTTPSErrors: options.ignoreHTTPSErrors
                            })];
                    case 1:
                        browser = _a.sent();
                        this.browser = browser;
                        return [2 /*return*/, this];
                }
            });
        });
    };
    PuppeteerBrowser.prototype.newPage = function () {
        return __awaiter(this, void 0, void 0, function () {
            var options, page, exts_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = this.options;
                        return [4 /*yield*/, this.browser.newPage()];
                    case 1:
                        page = _a.sent();
                        if (!!options.showImages) return [3 /*break*/, 3];
                        return [4 /*yield*/, page.setRequestInterceptionEnabled(true)];
                    case 2:
                        _a.sent();
                        exts_1 = ['png', 'jpg', 'gif'];
                        page.on('request', function (req) {
                            if (utils_1.exists(exts_1, function (ext) { return req.url.endsWith('.' + ext); })) {
                                req.abort();
                            }
                            else {
                                req.continue();
                            }
                        });
                        _a.label = 3;
                    case 3: return [2 /*return*/, new PuppeteerPage_1.default(options, page)];
                }
            });
        });
    };
    PuppeteerBrowser.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.browser.close()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return PuppeteerBrowser;
}(Browser_1.default));
exports.default = PuppeteerBrowser;
//# sourceMappingURL=PuppeteerBrowser.js.map